const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PaymentsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payments = await db.payments.create(
      {
        id: data.id || undefined,

        method: data.method || null,
        amount: data.amount || null,
        paid_at: data.paid_at || null,
        receipt_ref: data.receipt_ref || null,
        attachment_url: data.attachment_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await payments.setTenant(data.tenant || null, {
      transaction,
    });

    await payments.setReservation(data.reservation || null, {
      transaction,
    });

    await payments.setAgences(data.agences || null, {
      transaction,
    });

    return payments;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const paymentsData = data.map((item, index) => ({
      id: item.id || undefined,

      method: item.method || null,
      amount: item.amount || null,
      paid_at: item.paid_at || null,
      receipt_ref: item.receipt_ref || null,
      attachment_url: item.attachment_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const payments = await db.payments.bulkCreate(paymentsData, {
      transaction,
    });

    // For each item created, replace relation files

    return payments;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const payments = await db.payments.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.method !== undefined) updatePayload.method = data.method;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.paid_at !== undefined) updatePayload.paid_at = data.paid_at;

    if (data.receipt_ref !== undefined)
      updatePayload.receipt_ref = data.receipt_ref;

    if (data.attachment_url !== undefined)
      updatePayload.attachment_url = data.attachment_url;

    updatePayload.updatedById = currentUser.id;

    await payments.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await payments.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await payments.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await payments.setAgences(
        data.agences,

        { transaction },
      );
    }

    return payments;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payments = await db.payments.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of payments) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of payments) {
        await record.destroy({ transaction });
      }
    });

    return payments;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payments = await db.payments.findByPk(id, options);

    await payments.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await payments.destroy({
      transaction,
    });

    return payments;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const payments = await db.payments.findOne({ where }, { transaction });

    if (!payments) {
      return payments;
    }

    const output = payments.get({ plain: true });

    output.tenant = await payments.getTenant({
      transaction,
    });

    output.reservation = await payments.getReservation({
      transaction,
    });

    output.agences = await payments.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.receipt_ref) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('payments', 'receipt_ref', filter.receipt_ref),
        };
      }

      if (filter.attachment_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'payments',
            'attachment_url',
            filter.attachment_url,
          ),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.paid_atRange) {
        const [start, end] = filter.paid_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            paid_at: {
              ...where.paid_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            paid_at: {
              ...where.paid_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.method) {
        where = {
          ...where,
          method: filter.method,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.payments.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('payments', 'receipt_ref', query),
        ],
      };
    }

    const records = await db.payments.findAll({
      attributes: ['id', 'receipt_ref'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['receipt_ref', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.receipt_ref,
    }));
  }
};
